import { Slot } from '../componentSlots'
import {
  VNodeChildren,
  openBlock,
  createBlock,
  Fragment,
  VNode
} from '../vnode'

export function renderSlot(
  slot: Slot | undefined,
  props: any = {},
  // this is not a user-facing function, so the fallback is always generated by
  // the compiler and gurunteed to be an array
  fallback?: VNodeChildren
): VNode {
  return (
    openBlock(),
    createBlock(
      Fragment,
      { key: props.key },
      slot ? slot(props) : fallback || []
    )
  )
}
